From 663d44316ca81b36dea65e97dfd6d154cf545adf Mon Sep 17 00:00:00 2001
From: Egbert Eich <eich@suse.com>
Date: Mon, 23 May 2022 09:33:49 +0200
Subject: [PATCH 30/34] Add config CommunicationParameters for
 'block_null_hash' option

Signed-off-by: Egbert Eich <eich@suse.com>
---
 slurm/slurm.h.in                |  1 +
 src/common/read_config.c        |  6 ++++++
 src/common/slurm_protocol_api.c | 18 ++++++++++++++++++
 src/common/slurm_protocol_api.h |  6 ++++++
 4 files changed, 31 insertions(+)

diff --git a/slurm/slurm.h.in b/slurm/slurm.h.in
index 639a65a836..2b9fa1a9b9 100644
--- a/slurm/slurm.h.in
+++ b/slurm/slurm.h.in
@@ -2832,6 +2832,7 @@ typedef struct slurm_ctl_conf {
 	char *version;		/* version of slurmctld */
 	uint16_t vsize_factor;	/* virtual memory limit size factor */
 	uint16_t wait_time;	/* default job --wait time */
+        char *comm_params;      /* Communication parameters */
 	uint16_t z_16;		/* reserved for future use */
 	uint32_t z_32;		/* reserved for future use */
 	char *z_char;		/* reserved for future use */
diff --git a/src/common/read_config.c b/src/common/read_config.c
index ff494ef410..57c17a707d 100644
--- a/src/common/read_config.c
+++ b/src/common/read_config.c
@@ -186,6 +186,7 @@ s_p_options_t slurm_conf_options[] = {
 	{"ChosLoc", S_P_STRING},
 	{"CoreSpecPlugin", S_P_STRING},
 	{"ClusterName", S_P_STRING},
+	{"CommunicationParameters", S_P_STRING},
 	{"CompleteWait", S_P_UINT16},
 	{"ControlAddr", S_P_STRING},
 	{"ControlMachine", S_P_STRING},
@@ -2346,6 +2347,7 @@ free_slurm_conf (slurm_ctl_conf_t *ctl_conf_ptr, bool purge_node_hash)
 	xfree (ctl_conf_ptr->checkpoint_type);
 	xfree (ctl_conf_ptr->chos_loc);
 	xfree (ctl_conf_ptr->cluster_name);
+	xfree (ctl_conf_ptr->comm_params);
 	xfree (ctl_conf_ptr->control_addr);
 	xfree (ctl_conf_ptr->control_machine);
 	xfree (ctl_conf_ptr->core_spec_plugin);
@@ -2470,6 +2472,7 @@ init_slurm_conf (slurm_ctl_conf_t *ctl_conf_ptr)
 	xfree (ctl_conf_ptr->checkpoint_type);
 	xfree (ctl_conf_ptr->chos_loc);
 	xfree (ctl_conf_ptr->cluster_name);
+	xfree (ctl_conf_ptr->comm_params);
 	ctl_conf_ptr->complete_wait		= (uint16_t) NO_VAL;
 	xfree (ctl_conf_ptr->control_addr);
 	xfree (ctl_conf_ptr->control_machine);
@@ -3091,6 +3094,9 @@ _validate_and_set_defaults(slurm_ctl_conf_t *conf, s_p_hashtbl_t *hashtbl)
 	if (s_p_get_uint16(&uint16_tmp, "CacheGroups", hashtbl) && uint16_tmp)
 		conf->group_info |= GROUP_CACHE;
 
+	(void) s_p_get_string(&conf->comm_params, "CommunicationParameters",
+                              hashtbl);
+
 	if (!s_p_get_string(&conf->core_spec_plugin, "CoreSpecPlugin",
 	    hashtbl)) {
 		conf->core_spec_plugin =
diff --git a/src/common/slurm_protocol_api.c b/src/common/slurm_protocol_api.c
index 600f87390c..1f4ccbacfa 100644
--- a/src/common/slurm_protocol_api.c
+++ b/src/common/slurm_protocol_api.c
@@ -1160,6 +1160,24 @@ char *slurm_get_cluster_name(void)
 	return name;
 }
 
+/* slurm_get_comm_parameters
+ * returns the value of comm_param in slurmctld_conf object
+ * RET char *    - comm parameters, MUST be xfreed by caller
+ */
+extern char *slurm_get_comm_parameters(void)
+{
+	char *comm_params = NULL;
+        slurm_ctl_conf_t *conf;
+
+        if (slurmdbd_conf) {
+        } else {
+                conf = slurm_conf_lock();
+                comm_params = xstrdup(conf->comm_params);
+                slurm_conf_unlock();
+        }
+        return comm_params;
+}
+
 /* slurm_get_crypto_type
  * returns the crypto_type from slurmctld_conf object
  * RET char *    - crypto type, MUST be xfreed by caller
diff --git a/src/common/slurm_protocol_api.h b/src/common/slurm_protocol_api.h
index 4fa8ed6ec2..aab1b2d9f6 100644
--- a/src/common/slurm_protocol_api.h
+++ b/src/common/slurm_protocol_api.h
@@ -470,6 +470,12 @@ extern char *slurm_get_checkpoint_dir(void);
  */
 char *slurm_get_cluster_name(void);
 
+/* slurm_get_comm_parameters
+ * returns the value of comm_param in slurmctld_conf object
+ * RET char *    - comm parameters, MUST be xfreed by caller
+ */
+extern char *slurm_get_comm_parameters(void);
+
 /* slurm_get_crypto_type
  * returns the crypto_type from slurmctld_conf object
  * RET char *    - crypto type, MUST be xfreed by caller
-- 
2.35.3


